import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.video.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Conversion_calto extends PApplet {



Movie film;
byte[] frames;
int nb_frames = 0;
int position = 0;
int frame_actuelle = 0;
int largeur_film = 0,
    hauteur_film = 0,
    largeur_max = 0;

public void setup() {
  size(128, 64);
  film = new Movie(this, "video.mp4");
  film.play();
  nb_frames = (int)film.duration() * 25;
  frames = new byte[nb_frames * 1024];
  film.read();
  largeur_film = film.width;
  hauteur_film = film.height;
  if(hauteur_film == 0) {
    background(255);
    fill(0);
    textAlign(CENTER, CENTER);
    text("ERREUR", 64, 32);
    stop();
  }
  largeur_max = PApplet.parseInt(64 / (float)hauteur_film * largeur_film);
  film.jump(0);
}

public void draw() {
  if(film.available()) {
    film.read();
    frame_actuelle++;
  } else {
    return;
  }
  
  PImage img = createImage(largeur_film, hauteur_film, RGB);
  img.pixels = film.pixels;
  img.resize(0, 64);
  
  int k = 0;
  String txt = "";
  for(int j = 0; j < 64; j++) {
    for(int i = 0; i < 128; i++) {
      int pixel = 0, couleur = 0;
      if(i >= largeur_max) {
        pixel = 0;
        couleur = 255;
      } else {
        pixel = img.get(i, j);
        couleur = PApplet.parseInt(red(pixel) * 0.3f + green(pixel) * 0.59f + blue(pixel) * 0.11f);
        pixel = couleur < 127 ? 1 : 0;
      }
      img.set(i, j, color(255 - pixel * 255));
      
      k++;
      txt += str(pixel);
      if(k == 8) {
        k = 0;
        int nb = 0, m = 128;
        for(int l = 0; l < 8; l++) {
          nb += (txt.charAt(l) - '0') * m;
          m /= 2;
        }
        frames[position] = (byte)nb;
        position++;
        txt = "";
      }
    }
  }
  
  image(img, 0, 0);
  if(frame_actuelle == nb_frames) {
    saveBytes("data/VIDEO.CVF", frames);
    noLoop();
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Conversion_calto" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
